Workaround hlint behaviour with no warnings/errors
[ganeti-local] / Makefile.am
1 # Ganeti makefile
2 # - Indent with tabs only.
3 # - Keep files sorted; one line per file.
4 # - Directories in lib/ must have their own *dir variable (see hypervisor).
5 # - All directories must be listed DIRS.
6 # - Use autogen.sh to generate Makefile.in and configure script.
7
8 # Automake doesn't export these variables before version 1.10.
9 abs_top_builddir = @abs_top_builddir@
10 abs_top_srcdir = @abs_top_srcdir@
11
12 # Helper values for calling builtin functions
13 empty :=
14 space := $(empty) $(empty)
15 comma := ,
16
17 # Use bash in order to be able to use pipefail
18 SHELL=/bin/bash
19
20 ACLOCAL_AMFLAGS = -I autotools
21 BUILD_BASH_COMPLETION = $(top_srcdir)/autotools/build-bash-completion
22 RUN_IN_TEMPDIR = $(top_srcdir)/autotools/run-in-tempdir
23 CHECK_PYTHON_CODE = $(top_srcdir)/autotools/check-python-code
24 CHECK_HEADER = $(top_srcdir)/autotools/check-header
25 CHECK_MAN_DASHES = $(top_srcdir)/autotools/check-man-dashes
26 CHECK_MAN_REFERENCES = $(top_srcdir)/autotools/check-man-references
27 CHECK_MAN_WARNINGS = $(top_srcdir)/autotools/check-man-warnings
28 CHECK_VERSION = $(top_srcdir)/autotools/check-version
29 CHECK_NEWS = $(top_srcdir)/autotools/check-news
30 CHECK_IMPORTS = $(top_srcdir)/autotools/check-imports
31 DOCPP = $(top_srcdir)/autotools/docpp
32 REPLACE_VARS_SED = autotools/replace_vars.sed
33 CONVERT_CONSTANTS = $(top_srcdir)/autotools/convert-constants
34 BUILD_RPC = $(top_srcdir)/autotools/build-rpc
35 SHELL_ENV_INIT = autotools/shell-env-init
36
37 # Note: these are automake-specific variables, and must be named after
38 # the directory + 'dir' suffix
39 clientdir = $(pkgpythondir)/client
40 hypervisordir = $(pkgpythondir)/hypervisor
41 httpdir = $(pkgpythondir)/http
42 masterddir = $(pkgpythondir)/masterd
43 confddir = $(pkgpythondir)/confd
44 rapidir = $(pkgpythondir)/rapi
45 serverdir = $(pkgpythondir)/server
46 watcherdir = $(pkgpythondir)/watcher
47 impexpddir = $(pkgpythondir)/impexpd
48 utilsdir = $(pkgpythondir)/utils
49 toolsdir = $(pkglibdir)/tools
50 iallocatorsdir = $(pkglibdir)/iallocators
51 pytoolsdir = $(pkgpythondir)/tools
52 docdir = $(datadir)/doc/$(PACKAGE)
53 myexeclibdir = $(pkglibdir)
54
55 # Delete output file if an error occurred while building it
56 .DELETE_ON_ERROR:
57
58 HS_DIRS = \
59         src \
60         src/Ganeti \
61         src/Ganeti/Block \
62         src/Ganeti/Block/Drbd \
63         src/Ganeti/Confd \
64         src/Ganeti/DataCollectors \
65         src/Ganeti/HTools \
66         src/Ganeti/HTools/Backend \
67         src/Ganeti/HTools/Program \
68         src/Ganeti/Query \
69         test/hs \
70         test/hs/Test \
71         test/hs/Test/Ganeti \
72         test/hs/Test/Ganeti/Block \
73         test/hs/Test/Ganeti/Block/Drbd \
74         test/hs/Test/Ganeti/Confd \
75         test/hs/Test/Ganeti/HTools \
76         test/hs/Test/Ganeti/HTools/Backend \
77         test/hs/Test/Ganeti/Query
78
79 DIRS = \
80         $(HS_DIRS) \
81         autotools \
82         daemons \
83         devel \
84         doc \
85         doc/css \
86         doc/examples \
87         doc/examples/gnt-debug \
88         doc/examples/hooks \
89         test/data/htools \
90         test/data/htools/rapi \
91         test/hs/shelltests \
92         lib \
93         lib/build \
94         lib/client \
95         lib/confd \
96         lib/http \
97         lib/hypervisor \
98         lib/impexpd \
99         lib/masterd \
100         lib/rapi \
101         lib/server \
102         lib/tools \
103         lib/utils \
104         lib/watcher \
105         man \
106         qa \
107         test \
108         test/data \
109         test/data/ovfdata \
110         test/data/ovfdata/other \
111         test/py \
112         tools
113
114 ALL_APIDOC_HS_DIRS = \
115         $(APIDOC_HS_DIR) \
116         $(APIDOC_HS_DIR)/Ganeti \
117         $(APIDOC_HS_DIR)/Ganeti/Block \
118         $(APIDOC_HS_DIR)/Ganeti/Block/Drbd \
119         $(APIDOC_HS_DIR)/Ganeti/Confd \
120         $(APIDOC_HS_DIR)/Ganeti/DataCollectors \
121         $(APIDOC_HS_DIR)/Ganeti/HTools \
122         $(APIDOC_HS_DIR)/Ganeti/HTools/Backend \
123         $(APIDOC_HS_DIR)/Ganeti/HTools/Program \
124         $(APIDOC_HS_DIR)/Ganeti/Query
125
126 BUILDTIME_DIR_AUTOCREATE = \
127         scripts \
128         $(APIDOC_DIR) \
129         $(ALL_APIDOC_HS_DIRS) \
130         $(APIDOC_PY_DIR) \
131         $(COVERAGE_DIR) \
132         $(COVERAGE_HS_DIR) \
133         $(COVERAGE_PY_DIR) \
134         .hpc
135
136 BUILDTIME_DIRS = \
137         $(BUILDTIME_DIR_AUTOCREATE) \
138         doc/html \
139         doc/man-html
140
141 DIRCHECK_EXCLUDE = \
142         $(BUILDTIME_DIRS) \
143         ganeti-[0-9]*.[0-9]*.[0-9]* \
144         doc/html/_* \
145         doc/man-html/_* \
146         autom4te.cache
147
148 # some helper vars
149 COVERAGE_DIR = doc/coverage
150 COVERAGE_PY_DIR = $(COVERAGE_DIR)/py
151 COVERAGE_HS_DIR = $(COVERAGE_DIR)/hs
152 APIDOC_DIR = doc/api
153 APIDOC_PY_DIR = $(APIDOC_DIR)/py
154 APIDOC_HS_DIR = $(APIDOC_DIR)/hs
155
156 MAINTAINERCLEANFILES = \
157         $(maninput) \
158         doc/install-quick.rst \
159         doc/news.rst \
160         doc/upgrade.rst \
161         vcs-version
162
163 maintainer-clean-local:
164         rm -rf $(BUILDTIME_DIRS)
165
166 CLEANFILES = \
167         $(addsuffix /*.py[co],$(DIRS)) \
168         $(addsuffix /*.hi,$(HS_DIRS)) \
169         $(addsuffix /*.o,$(HS_DIRS)) \
170         $(PYTHON_BOOTSTRAP) \
171         epydoc.conf \
172         $(REPLACE_VARS_SED) \
173         $(SHELL_ENV_INIT) \
174         daemons/daemon-util \
175         daemons/ganeti-cleaner \
176         $(mandocrst) \
177         doc/manpages-enabled.rst \
178         $(BUILT_EXAMPLES) \
179         doc/examples/bash_completion \
180         doc/examples/bash_completion-debug \
181         lib/_generated_rpc.py \
182         $(man_MANS) \
183         $(manhtml) \
184         tools/kvm-ifup \
185         tools/vcluster-setup \
186         stamp-directories \
187         stamp-srclinks \
188         $(nodist_pkgpython_PYTHON) \
189         $(HS_ALL_PROGS) $(HS_BUILT_SRCS) \
190         $(HS_BUILT_TEST_HELPERS) \
191         src/ganeti-confd \
192         .hpc/*.mix src/*.tix test/hs/*.tix \
193         doc/hs-lint.html
194
195 GENERATED_FILES = \
196         $(built_base_sources) \
197         $(BUILT_PYTHON_SOURCES) \
198         $(PYTHON_BOOTSTRAP)
199
200 HS_GENERATED_FILES =
201 if WANT_HTOOLS
202 HS_GENERATED_FILES += $(HS_PROGS)
203 if ENABLE_CONFD
204 HS_GENERATED_FILES += src/hconfd src/ganeti-confd
205 endif
206 endif
207
208 built_base_sources = \
209         stamp-directories \
210         stamp-srclinks
211
212 built_python_base_sources = \
213         lib/_autoconf.py \
214         lib/_vcsversion.py
215
216 BUILT_PYTHON_SOURCES = \
217         $(built_python_base_sources) \
218         lib/_generated_rpc.py
219
220 # Generating the RPC wrappers depends on many things, so make sure
221 # it's built at the end of the built sources
222 lib/_generated_rpc.py: | $(built_base_sources) $(built_python_base_sources)
223
224 # these are all built from the underlying %.in sources
225 BUILT_EXAMPLES = \
226         doc/examples/ganeti-kvm-poweroff.initd \
227         doc/examples/ganeti.cron \
228         doc/examples/ganeti.initd \
229         doc/examples/ganeti-master-role.ocf \
230         doc/examples/ganeti-node-role.ocf \
231         doc/examples/gnt-config-backup \
232         doc/examples/hooks/ipsec
233
234 nodist_pkgpython_PYTHON = \
235         $(BUILT_PYTHON_SOURCES)
236
237 noinst_PYTHON = \
238         lib/build/__init__.py \
239         lib/build/shell_example_lexer.py \
240         lib/build/sphinx_ext.py
241
242 pkgpython_PYTHON = \
243         lib/__init__.py \
244         lib/asyncnotifier.py \
245         lib/backend.py \
246         lib/bdev.py \
247         lib/bootstrap.py \
248         lib/cli.py \
249         lib/cmdlib.py \
250         lib/compat.py \
251         lib/config.py \
252         lib/constants.py \
253         lib/daemon.py \
254         lib/errors.py \
255         lib/ht.py \
256         lib/jqueue.py \
257         lib/jstore.py \
258         lib/locking.py \
259         lib/luxi.py \
260         lib/mcpu.py \
261         lib/netutils.py \
262         lib/objects.py \
263         lib/objectutils.py \
264         lib/opcodes.py \
265         lib/ovf.py \
266         lib/pathutils.py \
267         lib/qlang.py \
268         lib/query.py \
269         lib/rpc.py \
270         lib/rpc_defs.py \
271         lib/runtime.py \
272         lib/serializer.py \
273         lib/ssconf.py \
274         lib/ssh.py \
275         lib/storage.py \
276         lib/uidpool.py \
277         lib/vcluster.py \
278         lib/network.py \
279         lib/workerpool.py
280
281 client_PYTHON = \
282         lib/client/__init__.py \
283         lib/client/gnt_backup.py \
284         lib/client/gnt_cluster.py \
285         lib/client/gnt_debug.py \
286         lib/client/gnt_group.py \
287         lib/client/gnt_instance.py \
288         lib/client/gnt_job.py \
289         lib/client/gnt_node.py \
290         lib/client/gnt_network.py \
291         lib/client/gnt_os.py \
292         lib/client/gnt_storage.py
293
294 hypervisor_PYTHON = \
295         lib/hypervisor/__init__.py \
296         lib/hypervisor/hv_base.py \
297         lib/hypervisor/hv_chroot.py \
298         lib/hypervisor/hv_fake.py \
299         lib/hypervisor/hv_kvm.py \
300         lib/hypervisor/hv_lxc.py \
301         lib/hypervisor/hv_xen.py
302
303 rapi_PYTHON = \
304         lib/rapi/__init__.py \
305         lib/rapi/baserlib.py \
306         lib/rapi/client.py \
307         lib/rapi/client_utils.py \
308         lib/rapi/connector.py \
309         lib/rapi/rlib2.py \
310         lib/rapi/testutils.py
311
312 http_PYTHON = \
313         lib/http/__init__.py \
314         lib/http/auth.py \
315         lib/http/client.py \
316         lib/http/server.py
317
318 confd_PYTHON = \
319         lib/confd/__init__.py \
320         lib/confd/client.py
321
322 masterd_PYTHON = \
323         lib/masterd/__init__.py \
324         lib/masterd/iallocator.py \
325         lib/masterd/instance.py
326
327 impexpd_PYTHON = \
328         lib/impexpd/__init__.py
329
330 watcher_PYTHON = \
331         lib/watcher/__init__.py \
332         lib/watcher/nodemaint.py \
333         lib/watcher/state.py
334
335 server_PYTHON = \
336         lib/server/__init__.py \
337         lib/server/masterd.py \
338         lib/server/noded.py \
339         lib/server/rapi.py
340
341 pytools_PYTHON = \
342         lib/tools/__init__.py \
343         lib/tools/burnin.py \
344         lib/tools/ensure_dirs.py \
345         lib/tools/node_cleanup.py \
346         lib/tools/node_daemon_setup.py \
347         lib/tools/prepare_node_join.py
348
349 utils_PYTHON = \
350         lib/utils/__init__.py \
351         lib/utils/algo.py \
352         lib/utils/filelock.py \
353         lib/utils/hash.py \
354         lib/utils/io.py \
355         lib/utils/log.py \
356         lib/utils/lvm.py \
357         lib/utils/mlock.py \
358         lib/utils/nodesetup.py \
359         lib/utils/process.py \
360         lib/utils/retry.py \
361         lib/utils/text.py \
362         lib/utils/wrapper.py \
363         lib/utils/x509.py
364
365 docinput = \
366         doc/conf.py \
367         doc/css/style.css \
368         doc/admin.rst \
369         doc/cluster-merge.rst \
370         doc/design-2.0.rst \
371         doc/design-2.1.rst \
372         doc/design-2.2.rst \
373         doc/design-2.3.rst \
374         doc/design-2.4.rst \
375         doc/design-2.5.rst \
376         doc/design-2.6.rst \
377         doc/design-2.7.rst \
378         doc/design-autorepair.rst \
379         doc/design-bulk-create.rst \
380         doc/design-chained-jobs.rst \
381         doc/design-cpu-pinning.rst \
382         doc/design-draft.rst \
383         doc/design-htools-2.3.rst \
384         doc/design-http-server.rst \
385         doc/design-impexp2.rst \
386         doc/design-lu-generated-jobs.rst \
387         doc/design-linuxha.rst \
388         doc/design-multi-reloc.rst \
389         doc/design-network.rst \
390         doc/design-node-add.rst \
391         doc/design-oob.rst \
392         doc/design-ovf-support.rst \
393         doc/design-opportunistic-locking.rst \
394         doc/design-partitioned.rst \
395         doc/design-query-splitting.rst \
396         doc/design-query2.rst \
397         doc/design-remote-commands.rst \
398         doc/design-resource-model.rst \
399         doc/design-shared-storage.rst \
400         doc/design-monitoring-agent.rst \
401         doc/design-virtual-clusters.rst \
402         doc/design-x509-ca.rst \
403         doc/devnotes.rst \
404         doc/glossary.rst \
405         doc/hooks.rst \
406         doc/iallocator.rst \
407         doc/index.rst \
408         doc/install-quick.rst \
409         doc/install.rst \
410         doc/locking.rst \
411         doc/manpages-disabled.rst \
412         doc/move-instance.rst \
413         doc/news.rst \
414         doc/ovfconverter.rst \
415         doc/rapi.rst \
416         doc/security.rst \
417         doc/upgrade.rst \
418         doc/virtual-cluster.rst \
419         doc/walkthrough.rst
420
421 # Generates file names such as "doc/man-gnt-instance.rst"
422 mandocrst = $(addprefix doc/man-,$(notdir $(manrst)))
423
424 # Haskell programs to be installed in $PREFIX/bin
425 HS_BIN_PROGS=src/htools
426
427 # Haskell programs to be installed in the MYEXECLIB dir
428 HS_MYEXECLIB_PROGS=src/mon-collector
429
430 # Haskell programs to compiled but not installed automatically
431 # Usually they have their own specific installation rules
432 HS_COMPILE_PROGS= \
433         src/hconfd \
434         src/rpc-test
435
436 # All Haskell non-test programs to be compiled but not automatically installed
437 HS_PROGS = $(HS_BIN_PROGS) $(HS_MYEXECLIB_PROGS)
438
439 HS_BIN_ROLES = hbal hscan hspace hinfo hcheck hroller
440 HS_HTOOLS_PROGS = $(HS_BIN_ROLES) hail
441
442 HS_ALL_PROGS = \
443         $(HS_PROGS) \
444         test/hs/hpc-htools \
445         test/hs/hpc-mon-collector \
446         test/hs/htest \
447         $(HS_COMPILE_PROGS)
448
449 HS_PROG_SRCS = $(patsubst %,%.hs,$(HS_ALL_PROGS))
450 HS_BUILT_TEST_HELPERS = $(HS_BIN_ROLES:%=test/hs/%) test/hs/hail
451
452 HFLAGS = \
453         -O -Wall -Werror -isrc \
454         -fwarn-monomorphism-restriction \
455         -fwarn-tabs \
456         $(GHC_BYVERSION_FLAGS)
457
458 # extra flags that can be overriden on the command line (e.g. -Wwarn, etc.)
459 HEXTRA =
460 # internal extra flags (used for test/hs/htest mainly)
461 HEXTRA_INT =
462 # exclude options for coverage reports
463 HPCEXCL = --exclude Main \
464         --exclude Ganeti.Constants \
465         --exclude Ganeti.HTools.QC \
466         --exclude Ganeti.THH \
467         --exclude Ganeti.Version \
468         --exclude Test.Ganeti.Attoparsec \
469         --exclude Test.Ganeti.TestCommon \
470         --exclude Test.Ganeti.TestHTools \
471         --exclude Test.Ganeti.TestHelper \
472         --exclude Test.Ganeti.TestImports \
473         $(patsubst src.%,--exclude Test.%,$(subst /,.,$(patsubst %.hs,%, $(HS_LIB_SRCS))))
474
475 HS_LIB_SRCS = \
476         src/Ganeti/Block/Drbd/Types.hs \
477         src/Ganeti/Block/Drbd/Parser.hs \
478         src/Ganeti/BasicTypes.hs \
479         src/Ganeti/Common.hs \
480         src/Ganeti/Compat.hs \
481         src/Ganeti/Confd/Client.hs \
482         src/Ganeti/Confd/Server.hs \
483         src/Ganeti/Confd/Types.hs \
484         src/Ganeti/Confd/Utils.hs \
485         src/Ganeti/Config.hs \
486         src/Ganeti/Daemon.hs \
487         src/Ganeti/DataCollectors/CLI.hs \
488         src/Ganeti/DataCollectors/Drbd.hs \
489         src/Ganeti/DataCollectors/Program.hs \
490         src/Ganeti/DataCollectors/Types.hs \
491         src/Ganeti/Errors.hs \
492         src/Ganeti/HTools/Backend/IAlloc.hs \
493         src/Ganeti/HTools/Backend/Luxi.hs \
494         src/Ganeti/HTools/Backend/Rapi.hs \
495         src/Ganeti/HTools/Backend/Simu.hs \
496         src/Ganeti/HTools/Backend/Text.hs \
497         src/Ganeti/HTools/CLI.hs \
498         src/Ganeti/HTools/Cluster.hs \
499         src/Ganeti/HTools/Container.hs \
500         src/Ganeti/HTools/ExtLoader.hs \
501         src/Ganeti/HTools/Graph.hs \
502         src/Ganeti/HTools/Group.hs \
503         src/Ganeti/HTools/Instance.hs \
504         src/Ganeti/HTools/Loader.hs \
505         src/Ganeti/HTools/Node.hs \
506         src/Ganeti/HTools/PeerMap.hs \
507         src/Ganeti/HTools/Program/Hail.hs \
508         src/Ganeti/HTools/Program/Hbal.hs \
509         src/Ganeti/HTools/Program/Hcheck.hs \
510         src/Ganeti/HTools/Program/Hinfo.hs \
511         src/Ganeti/HTools/Program/Hscan.hs \
512         src/Ganeti/HTools/Program/Hspace.hs \
513         src/Ganeti/HTools/Program/Hroller.hs \
514         src/Ganeti/HTools/Program/Main.hs \
515         src/Ganeti/HTools/Types.hs \
516         src/Ganeti/Hash.hs \
517         src/Ganeti/JQueue.hs \
518         src/Ganeti/JSON.hs \
519         src/Ganeti/Jobs.hs \
520         src/Ganeti/Logging.hs \
521         src/Ganeti/Luxi.hs \
522         src/Ganeti/Network.hs \
523         src/Ganeti/Objects.hs \
524         src/Ganeti/OpCodes.hs \
525         src/Ganeti/OpParams.hs \
526         src/Ganeti/Path.hs \
527         src/Ganeti/Query/Common.hs \
528         src/Ganeti/Query/Filter.hs \
529         src/Ganeti/Query/Group.hs \
530         src/Ganeti/Query/Job.hs \
531         src/Ganeti/Query/Language.hs \
532         src/Ganeti/Query/Node.hs \
533         src/Ganeti/Query/Query.hs \
534         src/Ganeti/Query/Server.hs \
535         src/Ganeti/Query/Types.hs \
536         src/Ganeti/Rpc.hs \
537         src/Ganeti/Runtime.hs \
538         src/Ganeti/Ssconf.hs \
539         src/Ganeti/THH.hs \
540         src/Ganeti/Types.hs \
541         src/Ganeti/Utils.hs
542
543 HS_TEST_SRCS = \
544         test/hs/Test/Ganeti/Attoparsec.hs \
545         test/hs/Test/Ganeti/BasicTypes.hs \
546         test/hs/Test/Ganeti/Block/Drbd/Parser.hs \
547         test/hs/Test/Ganeti/Block/Drbd/Types.hs \
548         test/hs/Test/Ganeti/Common.hs \
549         test/hs/Test/Ganeti/Confd/Types.hs \
550         test/hs/Test/Ganeti/Confd/Utils.hs \
551         test/hs/Test/Ganeti/Daemon.hs \
552         test/hs/Test/Ganeti/Errors.hs \
553         test/hs/Test/Ganeti/HTools/Backend/Simu.hs \
554         test/hs/Test/Ganeti/HTools/Backend/Text.hs \
555         test/hs/Test/Ganeti/HTools/CLI.hs \
556         test/hs/Test/Ganeti/HTools/Cluster.hs \
557         test/hs/Test/Ganeti/HTools/Container.hs \
558         test/hs/Test/Ganeti/HTools/Graph.hs \
559         test/hs/Test/Ganeti/HTools/Instance.hs \
560         test/hs/Test/Ganeti/HTools/Loader.hs \
561         test/hs/Test/Ganeti/HTools/Node.hs \
562         test/hs/Test/Ganeti/HTools/PeerMap.hs \
563         test/hs/Test/Ganeti/HTools/Types.hs \
564         test/hs/Test/Ganeti/JSON.hs \
565         test/hs/Test/Ganeti/Jobs.hs \
566         test/hs/Test/Ganeti/JQueue.hs \
567         test/hs/Test/Ganeti/Luxi.hs \
568         test/hs/Test/Ganeti/Network.hs \
569         test/hs/Test/Ganeti/Objects.hs \
570         test/hs/Test/Ganeti/OpCodes.hs \
571         test/hs/Test/Ganeti/Query/Filter.hs \
572         test/hs/Test/Ganeti/Query/Language.hs \
573         test/hs/Test/Ganeti/Query/Query.hs \
574         test/hs/Test/Ganeti/Rpc.hs \
575         test/hs/Test/Ganeti/Runtime.hs \
576         test/hs/Test/Ganeti/Ssconf.hs \
577         test/hs/Test/Ganeti/THH.hs \
578         test/hs/Test/Ganeti/TestCommon.hs \
579         test/hs/Test/Ganeti/TestHTools.hs \
580         test/hs/Test/Ganeti/TestHelper.hs \
581         test/hs/Test/Ganeti/Types.hs \
582         test/hs/Test/Ganeti/Utils.hs
583
584 HS_LIBTEST_SRCS = $(HS_LIB_SRCS) $(HS_TEST_SRCS)
585
586 HS_BUILT_SRCS = \
587         test/hs/Test/Ganeti/TestImports.hs \
588         src/Ganeti/Constants.hs \
589         src/Ganeti/Version.hs
590 HS_BUILT_SRCS_IN = $(patsubst %,%.in,$(HS_BUILT_SRCS))
591
592 $(RUN_IN_TEMPDIR): | stamp-directories
593
594 doc/html/index.html: ENABLE_MANPAGES =
595 doc/man-html/index.html: ENABLE_MANPAGES = 1
596 doc/man-html/index.html: doc/manpages-enabled.rst $(mandocrst)
597
598 # Note: we use here an order-only prerequisite, as the contents of
599 # _autoconf.py are not actually influencing the html build output: it
600 # has to exist in order for the sphinx module to be loaded
601 # successfully, but we certainly don't want the docs to be rebuilt if
602 # it changes
603 doc/html/index.html doc/man-html/index.html: $(docinput) doc/conf.py \
604         configure.ac $(RUN_IN_TEMPDIR) lib/build/sphinx_ext.py \
605         lib/build/shell_example_lexer.py lib/opcodes.py lib/ht.py \
606         doc/css/style.css \
607         | $(BUILT_PYTHON_SOURCES)
608         @test -n "$(SPHINX)" || \
609             { echo 'sphinx-build' not found during configure; exit 1; }
610 if !MANPAGES_IN_DOC
611         if test -n '$(ENABLE_MANPAGES)'; then \
612           echo 'Man pages in documentation were disabled at configure time' >&2; \
613           exit 1; \
614         fi
615 endif
616 ## Sphinx provides little control over what content should be included. Some
617 ## mechanisms exist, but they all have drawbacks or actual issues. Since we
618 ## build two different versions of the documentation--once without man pages and
619 ## once, if enabled, with them--some control is necessary. xmpp-wrapper provides
620 ## us with this, but requires running in a temporary directory. It moves the
621 ## correct files into place depending on environment variables.
622         dir=$(dir $@) && \
623         @mkdir_p@ $$dir && \
624         PYTHONPATH=. ENABLE_MANPAGES=$(ENABLE_MANPAGES) COPY_DOC=1 \
625         $(RUN_IN_TEMPDIR) autotools/sphinx-wrapper $(SPHINX) -q -W -b html \
626             -d . \
627             -D version="$(VERSION_MAJOR).$(VERSION_MINOR)" \
628             -D release="$(PACKAGE_VERSION)" \
629             -D graphviz_dot="$(DOT)" \
630             -D enable_manpages="$(ENABLE_MANPAGES)" \
631             doc $(CURDIR)/$$dir && \
632         rm -f $$dir/.buildinfo $$dir/objects.inv
633         touch $@
634
635 doc/html: doc/html/index.html
636
637 doc/man-html: doc/man-html/index.html
638
639 doc/install-quick.rst: INSTALL
640 doc/news.rst: NEWS
641 doc/upgrade.rst: UPGRADE
642
643 doc/install-quick.rst doc/news.rst doc/upgrade.rst:
644         set -e; \
645         { echo '.. This file is automatically updated at build time from $<.'; \
646           echo '.. Do not edit.'; \
647           echo; \
648           cat $<; \
649         } > $@
650
651 doc/manpages-enabled.rst: Makefile | $(built_base_sources)
652         { echo '.. This file is automatically generated, do not edit!'; \
653           echo ''; \
654           echo 'Man pages'; \
655           echo '========='; \
656           echo; \
657           echo '.. toctree::'; \
658           echo '   :maxdepth: 1'; \
659           echo; \
660           for i in $(notdir $(mandocrst)); do \
661             echo "   $$i"; \
662           done | LC_ALL=C sort; \
663         } > $@
664
665 doc/man-%.rst: man/%.gen Makefile $(REPLACE_VARS_SED) | $(built_base_sources)
666 if MANPAGES_IN_DOC
667         { echo '.. This file is automatically updated at build time from $<.'; \
668           echo '.. Do not edit.'; \
669           echo; \
670           echo "$*"; \
671           echo '=========================================='; \
672           tail -n +3 $< | sed -f $(REPLACE_VARS_SED); \
673         } > $@
674 else
675         echo 'Man pages in documentation were disabled at configure time' >&2; \
676         exit 1;
677 endif
678
679 # Things to build but not to install (add it to EXTRA_DIST if it should be
680 # distributed)
681 noinst_DATA = \
682         doc/html \
683         $(BUILT_EXAMPLES) \
684         doc/examples/bash_completion \
685         doc/examples/bash_completion-debug \
686         $(manhtml)
687
688 if MANPAGES_IN_DOC
689 noinst_DATA += doc/man-html
690 endif
691
692 gnt_scripts = \
693         scripts/gnt-backup \
694         scripts/gnt-cluster \
695         scripts/gnt-debug \
696         scripts/gnt-group \
697         scripts/gnt-instance \
698         scripts/gnt-job \
699         scripts/gnt-network \
700         scripts/gnt-node \
701         scripts/gnt-os \
702         scripts/gnt-storage
703
704 PYTHON_BOOTSTRAP_SBIN = \
705         daemons/ganeti-masterd \
706         daemons/ganeti-noded \
707         daemons/ganeti-rapi \
708         daemons/ganeti-watcher \
709         $(gnt_scripts)
710
711 PYTHON_BOOTSTRAP = \
712         $(PYTHON_BOOTSTRAP_SBIN) \
713         tools/burnin \
714         tools/ensure-dirs \
715         tools/node-cleanup \
716         tools/node-daemon-setup \
717         tools/prepare-node-join
718
719 qa_scripts = \
720         qa/__init__.py \
721         qa/ganeti-qa.py \
722         qa/qa_cluster.py \
723         qa/qa_config.py \
724         qa/qa_daemon.py \
725         qa/qa_env.py \
726         qa/qa_error.py \
727         qa/qa_group.py \
728         qa/qa_instance.py \
729         qa/qa_job.py \
730         qa/qa_node.py \
731         qa/qa_os.py \
732         qa/qa_rapi.py \
733         qa/qa_tags.py \
734         qa/qa_utils.py
735
736 bin_SCRIPTS =
737 if WANT_HTOOLS
738 bin_SCRIPTS += $(HS_BIN_PROGS)
739 install-exec-hook:
740         @mkdir_p@ $(DESTDIR)$(iallocatorsdir)
741 # FIXME: this is a hardcoded logic, instead of auto-resolving
742         $(LN_S) -f ../../../bin/htools \
743           $(DESTDIR)$(iallocatorsdir)/hail
744         for role in $(HS_BIN_ROLES); do \
745           $(LN_S) -f htools $(DESTDIR)$(bindir)/$$role ; \
746         done
747 endif
748
749 $(HS_ALL_PROGS): %: %.hs $(HS_LIBTEST_SRCS) $(HS_BUILT_SRCS) Makefile
750         @if [ "$(notdir $@)" = "test" ] && [ "$(HS_NODEV)" ]; then \
751           echo "Error: cannot run unittests without the development" \
752                " libraries (see devnotes.rst)" 1>&2; \
753           exit 1; \
754         fi
755         @rm -f $(notdir $@).tix
756         $(GHC) --make \
757           $(HFLAGS) \
758           $(HS_NOCURL) $(HS_PARALLEL3) $(HS_REGEX_PCRE) \
759           -osuf $(notdir $@).o -hisuf $(notdir $@).hi \
760           $(HEXTRA) $(HEXTRA_INT) $@
761         @touch "$@"
762
763 # for the test/hs/htest binary, we need to enable profiling/coverage
764 test/hs/htest: HEXTRA_INT=-fhpc -itest/hs
765
766 # we compile the hpc-htools binary with the program coverage
767 test/hs/hpc-htools: HEXTRA_INT=-fhpc
768
769 # we compile the hpc-mon-collector binary with the program coverage
770 test/hs/hpc-mon-collector: HEXTRA_INT=-fhpc
771
772 # test dependency
773 test/hs/offline-tests.sh: test/hs/hpc-htools test/hs/hpc-mon-collector
774
775 # rules for building profiling-enabled versions of the haskell
776 # programs: hs-prof does the full two-step build, whereas
777 # hs-prof-quick does only the final rebuild (hs-prof must have been
778 # run before)
779 .PHONY: hs-prof hs-prof-quick
780 hs-prof:
781         @if [ -z "$(TARGET)" ]; then \
782           echo "You need to define TARGET when running this rule" 1>&2; \
783           exit 1; \
784         fi
785         $(MAKE) $(AM_MAKEFLAGS) clean
786         $(MAKE) $(AM_MAKEFLAGS) $(TARGET) HEXTRA="-osuf o"
787         rm -f $(HS_ALL_PROGS)
788         $(MAKE) $(AM_MAKEFLAGS) hs-prof-quick
789
790 hs-prof-quick:
791         @if [ -z "$(TARGET)" ]; then \
792           echo "You need to define TARGET when running this rule" 1>&2; \
793           exit 1; \
794         fi
795         $(MAKE) $(AM_MAKEFLAGS) $(TARGET) HEXTRA="-osuf prof_o -prof -auto-all"
796
797 dist_sbin_SCRIPTS = \
798         tools/ganeti-listrunner
799
800 nodist_sbin_SCRIPTS = \
801         $(PYTHON_BOOTSTRAP_SBIN) \
802         daemons/ganeti-cleaner
803
804 if ENABLE_CONFD
805 src/ganeti-confd: src/hconfd
806         cp -f $< $@
807
808 nodist_sbin_SCRIPTS += src/ganeti-confd
809 endif
810
811 python_scripts = \
812         tools/cfgshell \
813         tools/cfgupgrade \
814         tools/cfgupgrade12 \
815         tools/cluster-merge \
816         tools/confd-client \
817         tools/fmtjson \
818         tools/lvmstrap \
819         tools/move-instance \
820         tools/ovfconverter \
821         tools/sanitize-config
822
823 dist_tools_SCRIPTS = \
824         $(python_scripts) \
825         tools/kvm-console-wrapper \
826         tools/master-ip-setup \
827         tools/xen-console-wrapper
828
829 nodist_tools_python_scripts = \
830         tools/node-cleanup
831
832 nodist_tools_SCRIPTS = \
833         $(nodist_tools_python_scripts) \
834         tools/vcluster-setup
835
836 pkglib_python_scripts = \
837         daemons/import-export \
838         tools/check-cert-expired
839
840 nodist_pkglib_python_scripts = \
841         tools/burnin \
842         tools/ensure-dirs \
843         tools/node-daemon-setup \
844         tools/prepare-node-join
845
846 myexeclib_SCRIPTS = \
847         daemons/daemon-util \
848         tools/kvm-ifup \
849         $(pkglib_python_scripts) \
850         $(HS_MYEXECLIB_PROGS)
851
852 nodist_myexeclib_SCRIPTS = \
853         $(nodist_pkglib_python_scripts)
854
855 EXTRA_DIST = \
856         NEWS \
857         UPGRADE \
858         epydoc.conf.in \
859         pylintrc \
860         autotools/build-bash-completion \
861         autotools/build-rpc \
862         autotools/check-header \
863         autotools/check-imports \
864         autotools/check-man-dashes \
865         autotools/check-man-references \
866         autotools/check-man-warnings \
867         autotools/check-news \
868         autotools/check-python-code \
869         autotools/check-tar \
870         autotools/check-version \
871         autotools/convert-constants \
872         autotools/docpp \
873         autotools/gen-py-coverage \
874         autotools/sphinx-wrapper \
875         autotools/testrunner \
876         autotools/wrong-hardcoded-paths \
877         $(RUN_IN_TEMPDIR) \
878         daemons/daemon-util.in \
879         daemons/ganeti-cleaner.in \
880         $(pkglib_python_scripts) \
881         devel/upload \
882         devel/webserver \
883         tools/kvm-ifup.in \
884         tools/vcluster-setup.in \
885         $(docinput) \
886         doc/html \
887         $(BUILT_EXAMPLES:%=%.in) \
888         doc/examples/ganeti.default \
889         doc/examples/ganeti.default-debug \
890         doc/examples/hooks/ethers \
891         doc/examples/gnt-debug/README \
892         doc/examples/gnt-debug/delay0.json \
893         doc/examples/gnt-debug/delay50.json \
894         test/py/lockperf.py \
895         test/py/testutils.py \
896         test/py/mocks.py \
897         $(dist_TESTS) \
898         $(TEST_FILES) \
899         man/footer.rst \
900         $(manrst) \
901         $(maninput) \
902         qa/qa-sample.json \
903         $(qa_scripts) \
904         $(HS_LIBTEST_SRCS) $(HS_BUILT_SRCS_IN) \
905         $(HS_PROG_SRCS) \
906         src/lint-hints.hs \
907         test/hs/cli-tests-defs.sh \
908         test/hs/offline-test.sh \
909         .ghci
910
911 man_MANS = \
912         man/ganeti-cleaner.8 \
913         man/ganeti-confd.8 \
914         man/ganeti-listrunner.8 \
915         man/ganeti-masterd.8 \
916         man/ganeti-noded.8 \
917         man/ganeti-os-interface.7 \
918         man/ganeti-extstorage-interface.7 \
919         man/ganeti-rapi.8 \
920         man/ganeti-watcher.8 \
921         man/ganeti.7 \
922         man/gnt-backup.8 \
923         man/gnt-cluster.8 \
924         man/gnt-debug.8 \
925         man/gnt-group.8 \
926         man/gnt-network.8 \
927         man/gnt-instance.8 \
928         man/gnt-job.8 \
929         man/gnt-node.8 \
930         man/gnt-os.8 \
931         man/gnt-storage.8 \
932         man/hail.1 \
933         man/hbal.1 \
934         man/hcheck.1 \
935         man/hinfo.1 \
936         man/hscan.1 \
937         man/hspace.1 \
938         man/hroller.1 \
939         man/htools.1 \
940         man/mon-collector.7
941
942 # Remove extensions from all filenames in man_MANS
943 mannoext = $(patsubst %.1,%,$(patsubst %.7,%,$(patsubst %.8,%,$(man_MANS))))
944
945 manrst = $(patsubst %,%.rst,$(mannoext))
946 manhtml = $(patsubst %.rst,%.html,$(manrst))
947 mangen = $(patsubst %.rst,%.gen,$(manrst))
948 maninput = \
949         $(patsubst %.1,%.1.in,$(patsubst %.7,%.7.in,$(patsubst %.8,%.8.in,$(man_MANS)))) \
950         $(patsubst %.html,%.html.in,$(manhtml)) \
951         $(mangen)
952
953 TEST_FILES = \
954         test/data/htools/clean-nonzero-score.data \
955         test/data/htools/common-suffix.data \
956         test/data/htools/empty-cluster.data \
957         test/data/htools/hail-alloc-drbd.json \
958         test/data/htools/hail-change-group.json \
959         test/data/htools/hail-invalid-reloc.json \
960         test/data/htools/hail-node-evac.json \
961         test/data/htools/hail-reloc-drbd.json \
962         test/data/htools/hbal-excl-tags.data \
963         test/data/htools/hbal-split-insts.data \
964         test/data/htools/invalid-node.data \
965         test/data/htools/missing-resources.data \
966         test/data/htools/n1-failure.data \
967         test/data/htools/rapi/groups.json \
968         test/data/htools/rapi/info.json \
969         test/data/htools/rapi/instances.json \
970         test/data/htools/rapi/nodes.json \
971         test/hs/shelltests/htools-balancing.test \
972         test/hs/shelltests/htools-basic.test \
973         test/hs/shelltests/htools-dynutil.test \
974         test/hs/shelltests/htools-excl.test \
975         test/hs/shelltests/htools-hail.test \
976         test/hs/shelltests/htools-hspace.test \
977         test/hs/shelltests/htools-invalid.test \
978         test/hs/shelltests/htools-multi-group.test \
979         test/hs/shelltests/htools-no-backend.test \
980         test/hs/shelltests/htools-rapi.test \
981         test/hs/shelltests/htools-single-group.test \
982         test/hs/shelltests/htools-text-backend.test \
983         test/hs/shelltests/htools-mon-collector.test \
984         test/data/bdev-drbd-8.0.txt \
985         test/data/bdev-drbd-8.3.txt \
986         test/data/bdev-drbd-disk.txt \
987         test/data/bdev-drbd-net-ip4.txt \
988         test/data/bdev-drbd-net-ip6.txt \
989         test/data/cert1.pem \
990         test/data/cert2.pem \
991         test/data/instance-minor-pairing.txt \
992         test/data/ip-addr-show-dummy0.txt \
993         test/data/ip-addr-show-lo-ipv4.txt \
994         test/data/ip-addr-show-lo-ipv6.txt \
995         test/data/ip-addr-show-lo-oneline-ipv4.txt \
996         test/data/ip-addr-show-lo-oneline-ipv6.txt \
997         test/data/ip-addr-show-lo-oneline.txt \
998         test/data/ip-addr-show-lo.txt \
999         test/data/kvm_0.12.5_help.txt \
1000         test/data/kvm_0.15.90_help.txt \
1001         test/data/kvm_0.9.1_help.txt \
1002         test/data/kvm_0.9.1_help_boot_test.txt \
1003         test/data/kvm_1.0_help.txt \
1004         test/data/kvm_1.1.2_help.txt \
1005         test/data/ovfdata/compr_disk.vmdk.gz \
1006         test/data/ovfdata/config.ini \
1007         test/data/ovfdata/corrupted_resources.ovf \
1008         test/data/ovfdata/empty.ini \
1009         test/data/ovfdata/empty.ovf \
1010         test/data/ovfdata/ganeti.mf \
1011         test/data/ovfdata/ganeti.ovf \
1012         test/data/ovfdata/gzip_disk.ovf \
1013         test/data/ovfdata/new_disk.vmdk \
1014         test/data/ovfdata/no_disk.ini \
1015         test/data/ovfdata/no_disk_in_ref.ovf \
1016         test/data/ovfdata/no_os.ini \
1017         test/data/ovfdata/no_ovf.ova \
1018         test/data/ovfdata/other/rawdisk.raw \
1019         test/data/ovfdata/ova.ova \
1020         test/data/ovfdata/rawdisk.raw \
1021         test/data/ovfdata/second_disk.vmdk \
1022         test/data/ovfdata/unsafe_path.ini \
1023         test/data/ovfdata/virtualbox.ovf \
1024         test/data/ovfdata/wrong_config.ini \
1025         test/data/ovfdata/wrong_extension.ovd \
1026         test/data/ovfdata/wrong_manifest.mf \
1027         test/data/ovfdata/wrong_manifest.ovf \
1028         test/data/ovfdata/wrong_ova.ova \
1029         test/data/ovfdata/wrong_xml.ovf \
1030         test/data/proc_drbd8.txt \
1031         test/data/proc_drbd80-emptyline.txt \
1032         test/data/proc_drbd83.txt \
1033         test/data/proc_drbd83_sync.txt \
1034         test/data/proc_drbd83_sync_want.txt \
1035         test/data/proc_drbd83_sync_krnl2.6.39.txt \
1036         test/data/sys_drbd_usermode_helper.txt \
1037         test/data/vgreduce-removemissing-2.02.02.txt \
1038         test/data/vgreduce-removemissing-2.02.66-fail.txt \
1039         test/data/vgreduce-removemissing-2.02.66-ok.txt \
1040         test/data/vgs-missing-pvs-2.02.02.txt \
1041         test/data/vgs-missing-pvs-2.02.66.txt \
1042         test/py/ganeti-cli.test \
1043         test/py/gnt-cli.test \
1044         test/py/import-export_unittest-helper
1045
1046 python_tests = \
1047         doc/examples/rapi_testutils.py \
1048         test/py/cfgupgrade_unittest.py \
1049         test/py/docs_unittest.py \
1050         test/py/ganeti.asyncnotifier_unittest.py \
1051         test/py/ganeti.backend_unittest-runasroot.py \
1052         test/py/ganeti.backend_unittest.py \
1053         test/py/ganeti.bdev_unittest.py \
1054         test/py/ganeti.cli_unittest.py \
1055         test/py/ganeti.client.gnt_cluster_unittest.py \
1056         test/py/ganeti.client.gnt_instance_unittest.py \
1057         test/py/ganeti.client.gnt_job_unittest.py \
1058         test/py/ganeti.cmdlib_unittest.py \
1059         test/py/ganeti.compat_unittest.py \
1060         test/py/ganeti.confd.client_unittest.py \
1061         test/py/ganeti.config_unittest.py \
1062         test/py/ganeti.constants_unittest.py \
1063         test/py/ganeti.daemon_unittest.py \
1064         test/py/ganeti.errors_unittest.py \
1065         test/py/ganeti.hooks_unittest.py \
1066         test/py/ganeti.ht_unittest.py \
1067         test/py/ganeti.http_unittest.py \
1068         test/py/ganeti.hypervisor.hv_chroot_unittest.py \
1069         test/py/ganeti.hypervisor.hv_fake_unittest.py \
1070         test/py/ganeti.hypervisor.hv_kvm_unittest.py \
1071         test/py/ganeti.hypervisor.hv_lxc_unittest.py \
1072         test/py/ganeti.hypervisor.hv_xen_unittest.py \
1073         test/py/ganeti.hypervisor_unittest.py \
1074         test/py/ganeti.impexpd_unittest.py \
1075         test/py/ganeti.jqueue_unittest.py \
1076         test/py/ganeti.jstore_unittest.py \
1077         test/py/ganeti.locking_unittest.py \
1078         test/py/ganeti.luxi_unittest.py \
1079         test/py/ganeti.masterd.iallocator_unittest.py \
1080         test/py/ganeti.masterd.instance_unittest.py \
1081         test/py/ganeti.mcpu_unittest.py \
1082         test/py/ganeti.netutils_unittest.py \
1083         test/py/ganeti.objects_unittest.py \
1084         test/py/ganeti.objectutils_unittest.py \
1085         test/py/ganeti.opcodes_unittest.py \
1086         test/py/ganeti.ovf_unittest.py \
1087         test/py/ganeti.qlang_unittest.py \
1088         test/py/ganeti.query_unittest.py \
1089         test/py/ganeti.rapi.baserlib_unittest.py \
1090         test/py/ganeti.rapi.client_unittest.py \
1091         test/py/ganeti.rapi.resources_unittest.py \
1092         test/py/ganeti.rapi.rlib2_unittest.py \
1093         test/py/ganeti.rapi.testutils_unittest.py \
1094         test/py/ganeti.rpc_unittest.py \
1095         test/py/ganeti.runtime_unittest.py \
1096         test/py/ganeti.serializer_unittest.py \
1097         test/py/ganeti.server.rapi_unittest.py \
1098         test/py/ganeti.ssconf_unittest.py \
1099         test/py/ganeti.ssh_unittest.py \
1100         test/py/ganeti.storage_unittest.py \
1101         test/py/ganeti.tools.burnin_unittest.py \
1102         test/py/ganeti.tools.ensure_dirs_unittest.py \
1103         test/py/ganeti.tools.node_daemon_setup_unittest.py \
1104         test/py/ganeti.tools.prepare_node_join_unittest.py \
1105         test/py/ganeti.uidpool_unittest.py \
1106         test/py/ganeti.utils.algo_unittest.py \
1107         test/py/ganeti.utils.filelock_unittest.py \
1108         test/py/ganeti.utils.hash_unittest.py \
1109         test/py/ganeti.utils.io_unittest-runasroot.py \
1110         test/py/ganeti.utils.io_unittest.py \
1111         test/py/ganeti.utils.log_unittest.py \
1112         test/py/ganeti.utils.lvm_unittest.py \
1113         test/py/ganeti.utils.mlock_unittest.py \
1114         test/py/ganeti.utils.nodesetup_unittest.py \
1115         test/py/ganeti.utils.process_unittest.py \
1116         test/py/ganeti.utils.retry_unittest.py \
1117         test/py/ganeti.utils.text_unittest.py \
1118         test/py/ganeti.utils.wrapper_unittest.py \
1119         test/py/ganeti.utils.x509_unittest.py \
1120         test/py/ganeti.utils_unittest.py \
1121         test/py/ganeti.vcluster_unittest.py \
1122         test/py/ganeti.workerpool_unittest.py \
1123         test/py/pycurl_reset_unittest.py \
1124         test/py/qa.qa_config_unittest.py \
1125         test/py/tempfile_fork_unittest.py
1126
1127 haskell_tests = test/hs/htest
1128
1129 dist_TESTS = \
1130         test/py/check-cert-expired_unittest.bash \
1131         test/py/daemon-util_unittest.bash \
1132         test/py/ganeti-cleaner_unittest.bash \
1133         test/py/import-export_unittest.bash \
1134         test/py/cli-test.bash \
1135         test/py/bash_completion.bash \
1136         $(python_tests)
1137
1138 nodist_TESTS =
1139 check_SCRIPTS =
1140
1141 if WANT_HSTESTS
1142 nodist_TESTS += $(haskell_tests)
1143 dist_TESTS += test/hs/offline-test.sh
1144 check_SCRIPTS += \
1145         test/hs/hpc-htools \
1146         test/hs/hpc-mon-collector \
1147         $(HS_BUILT_TEST_HELPERS)
1148 endif
1149
1150 TESTS = $(dist_TESTS) $(nodist_TESTS)
1151
1152 # Environment for all tests
1153 PLAIN_TESTS_ENVIRONMENT = \
1154         PYTHONPATH=. \
1155         TOP_SRCDIR=$(abs_top_srcdir) TOP_BUILDDIR=$(abs_top_builddir) \
1156         PYTHON=$(PYTHON) FAKEROOT=$(FAKEROOT_PATH) \
1157         $(RUN_IN_TEMPDIR)
1158
1159 # Environment for tests run by automake
1160 TESTS_ENVIRONMENT = \
1161         $(PLAIN_TESTS_ENVIRONMENT) $(abs_top_srcdir)/autotools/testrunner
1162
1163 all_python_code = \
1164         $(dist_sbin_SCRIPTS) \
1165         $(python_scripts) \
1166         $(pkglib_python_scripts) \
1167         $(nodist_pkglib_python_scripts) \
1168         $(nodist_tools_python_scripts) \
1169         $(python_tests) \
1170         $(pkgpython_PYTHON) \
1171         $(client_PYTHON) \
1172         $(hypervisor_PYTHON) \
1173         $(rapi_PYTHON) \
1174         $(server_PYTHON) \
1175         $(pytools_PYTHON) \
1176         $(http_PYTHON) \
1177         $(confd_PYTHON) \
1178         $(masterd_PYTHON) \
1179         $(impexpd_PYTHON) \
1180         $(utils_PYTHON) \
1181         $(watcher_PYTHON) \
1182         $(noinst_PYTHON) \
1183         $(qa_scripts)
1184
1185 srclink_files = \
1186         man/footer.rst \
1187         test/py/check-cert-expired_unittest.bash \
1188         test/py/daemon-util_unittest.bash \
1189         test/py/ganeti-cleaner_unittest.bash \
1190         test/py/import-export_unittest.bash \
1191         test/py/cli-test.bash \
1192         test/py/bash_completion.bash \
1193         test/hs/offline-test.sh \
1194         test/hs/cli-tests-defs.sh \
1195         $(all_python_code) \
1196         $(HS_LIBTEST_SRCS) $(HS_PROG_SRCS) \
1197         $(docinput)
1198
1199 check_python_code = \
1200         $(BUILD_BASH_COMPLETION) \
1201         $(CHECK_IMPORTS) \
1202         $(CHECK_HEADER) \
1203         $(DOCPP) \
1204         $(all_python_code)
1205
1206 lint_python_code = \
1207         ganeti \
1208         ganeti/http/server.py \
1209         $(dist_sbin_SCRIPTS) \
1210         $(python_scripts) \
1211         $(pkglib_python_scripts) \
1212         $(BUILD_BASH_COMPLETION) \
1213         $(CHECK_IMPORTS) \
1214         $(CHECK_HEADER) \
1215         $(DOCPP) \
1216         $(PYTHON_BOOTSTRAP)
1217
1218 standalone_python_modules = \
1219         lib/rapi/client.py \
1220         tools/ganeti-listrunner
1221
1222 pep8_python_code = \
1223         ganeti \
1224         ganeti/http/server.py \
1225         $(dist_sbin_SCRIPTS) \
1226         $(python_scripts) \
1227         $(pkglib_python_scripts) \
1228         $(BUILD_BASH_COMPLETION) \
1229         $(CHECK_HEADER) \
1230         $(DOCPP) \
1231         $(PYTHON_BOOTSTRAP) \
1232         qa
1233
1234 test/py/daemon-util_unittest.bash: daemons/daemon-util
1235
1236 test/py/ganeti-cleaner_unittest.bash: daemons/ganeti-cleaner
1237
1238 test/py/bash_completion.bash: doc/examples/bash_completion-debug
1239
1240 tools/kvm-ifup: tools/kvm-ifup.in $(REPLACE_VARS_SED)
1241         sed -f $(REPLACE_VARS_SED) < $< > $@
1242         chmod +x $@
1243
1244 tools/vcluster-setup: tools/vcluster-setup.in $(REPLACE_VARS_SED)
1245         sed -f $(REPLACE_VARS_SED) < $< > $@
1246         chmod +x $@
1247
1248 daemons/%:: daemons/%.in $(REPLACE_VARS_SED)
1249         sed -f $(REPLACE_VARS_SED) < $< > $@
1250         chmod +x $@
1251
1252 doc/examples/%:: doc/examples/%.in $(REPLACE_VARS_SED)
1253         sed -f $(REPLACE_VARS_SED) < $< > $@
1254
1255 doc/examples/bash_completion: BC_ARGS = --compact
1256 doc/examples/bash_completion-debug: BC_ARGS =
1257
1258 doc/examples/bash_completion doc/examples/bash_completion-debug: \
1259         $(BUILD_BASH_COMPLETION) $(RUN_IN_TEMPDIR) \
1260         lib/cli.py $(gnt_scripts) $(client_PYTHON) tools/burnin \
1261         daemons/ganeti-cleaner \
1262         $(GENERATED_FILES) $(HS_GENERATED_FILES)
1263         PYTHONPATH=. $(RUN_IN_TEMPDIR) \
1264           $(CURDIR)/$(BUILD_BASH_COMPLETION) $(BC_ARGS) > $@
1265
1266 man/%.gen: man/%.rst lib/query.py lib/build/sphinx_ext.py \
1267         lib/build/shell_example_lexer.py \
1268         | $(RUN_IN_TEMPDIR) $(BUILT_PYTHON_SOURCES)
1269         @echo "Checking $< for hardcoded paths..."
1270         @if grep -nEf autotools/wrong-hardcoded-paths $<; then \
1271           echo "Man page $< has hardcoded paths (see above)!" 1>&2 ; \
1272           exit 1; \
1273         fi
1274         set -e ; \
1275         trap 'echo auto-removing $@; rm $@' EXIT; \
1276         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(DOCPP) < $< > $@ ;\
1277         $(CHECK_MAN_REFERENCES) $@; \
1278         trap - EXIT
1279
1280 man/%.7.in man/%.8.in man/%.1.in: man/%.gen man/footer.rst
1281         @test -n "$(PANDOC)" || \
1282           { echo 'pandoc' not found during configure; exit 1; }
1283         set -o pipefail ; \
1284         trap 'echo auto-removing $@; rm $@' EXIT; \
1285         $(PANDOC) -s -f rst -t man $< man/footer.rst | \
1286           sed -e 's/\\@/@/g' > $@; \
1287         if test -n "$(MAN_HAS_WARNINGS)"; then $(CHECK_MAN_WARNINGS) $@; fi; \
1288         $(CHECK_MAN_DASHES) $@; \
1289         trap - EXIT
1290
1291 man/%.html.in: man/%.gen man/footer.rst
1292         @test -n "$(PANDOC)" || \
1293           { echo 'pandoc' not found during configure; exit 1; }
1294         set -o pipefail ; \
1295         $(PANDOC) --toc -s -f rst -t html $< man/footer.rst | \
1296           sed -e 's/\\@/@/g' > $@
1297
1298 man/%: man/%.in  $(REPLACE_VARS_SED)
1299         sed -f $(REPLACE_VARS_SED) < $< > $@
1300
1301 epydoc.conf: epydoc.conf.in $(REPLACE_VARS_SED)
1302         sed -f $(REPLACE_VARS_SED) < $< > $@
1303
1304 vcs-version:
1305         if test -d .git; then \
1306           git describe > $@; \
1307         elif test ! -f $@ ; then \
1308           echo "Cannot auto-generate $@ file"; exit 1; \
1309         fi
1310
1311 .PHONY: clean-vcs-version
1312 clean-vcs-version:
1313         rm -f vcs-version
1314
1315 .PHONY: regen-vcs-version
1316 regen-vcs-version:
1317         @set -e; \
1318         cd $(srcdir); \
1319         if test -d .git; then \
1320           T=`mktemp` ; trap 'rm -f $$T' EXIT; \
1321           git describe > $$T; \
1322           if ! cmp --quiet $$T vcs-version; then \
1323             mv $$T vcs-version; \
1324           fi; \
1325         fi
1326
1327 src/Ganeti/Version.hs: src/Ganeti/Version.hs.in \
1328         vcs-version $(built_base_sources)
1329         set -e; \
1330         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
1331         sed -e "s/%ver%/$$VCSVER/" < $< > $@
1332
1333 src/Ganeti/Constants.hs: src/Ganeti/Constants.hs.in \
1334         lib/constants.py lib/_autoconf.py lib/luxi.py lib/errors.py \
1335         lib/jstore.py $(RUN_IN_TEMPDIR) \
1336         $(CONVERT_CONSTANTS) $(built_base_sources) \
1337         | lib/_vcsversion.py
1338         set -e; \
1339         { cat $< ; \
1340           PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(CONVERT_CONSTANTS); \
1341         } > $@
1342
1343 test/hs/Test/Ganeti/TestImports.hs: test/hs/Test/Ganeti/TestImports.hs.in \
1344         $(built_base_sources)
1345         set -e; \
1346         { cat $< ; \
1347           echo ; \
1348           for name in $(filter-out Ganeti.THH,$(subst /,.,$(patsubst %.hs,%,$(patsubst src/%,%,$(HS_LIB_SRCS))))) ; do \
1349             echo "import $$name ()" ; \
1350           done ; \
1351         } > $@
1352
1353 lib/_autoconf.py: Makefile | stamp-directories
1354         set -e; \
1355         { echo '# This file is automatically generated, do not edit!'; \
1356           echo '#'; \
1357           echo ''; \
1358           echo '"""Build-time configuration for Ganeti.'; \
1359           echo '';\
1360           echo 'This file is autogenerated by the build process.'; \
1361           echo 'For any changes you need to re-run ./configure (and'; \
1362           echo 'not edit by hand).'; \
1363           echo ''; \
1364           echo '"""'; \
1365           echo ''; \
1366           echo '# pylint: disable=C0301,C0324'; \
1367           echo '# because this is autogenerated, we do not want'; \
1368           echo '# style warnings' ; \
1369           echo ''; \
1370           echo "PACKAGE_VERSION = '$(PACKAGE_VERSION)'"; \
1371           echo "VERSION_MAJOR = '$(VERSION_MAJOR)'"; \
1372           echo "VERSION_MINOR = '$(VERSION_MINOR)'"; \
1373           echo "VERSION_REVISION = '$(VERSION_REVISION)'"; \
1374           echo "VERSION_SUFFIX = '$(VERSION_SUFFIX)'"; \
1375           echo "VERSION_FULL = '$(VERSION_FULL)'"; \
1376           echo "LOCALSTATEDIR = '$(localstatedir)'"; \
1377           echo "SYSCONFDIR = '$(sysconfdir)'"; \
1378           echo "SSH_CONFIG_DIR = '$(SSH_CONFIG_DIR)'"; \
1379           echo "SSH_LOGIN_USER = '$(SSH_LOGIN_USER)'"; \
1380           echo "SSH_CONSOLE_USER = '$(SSH_CONSOLE_USER)'"; \
1381           echo "EXPORT_DIR = '$(EXPORT_DIR)'"; \
1382           echo "OS_SEARCH_PATH = [$(OS_SEARCH_PATH)]"; \
1383           echo "ES_SEARCH_PATH = [$(ES_SEARCH_PATH)]"; \
1384           echo "XEN_BOOTLOADER = '$(XEN_BOOTLOADER)'"; \
1385           echo "XEN_CONFIG_DIR = '$(XEN_CONFIG_DIR)'"; \
1386           echo "XEN_KERNEL = '$(XEN_KERNEL)'"; \
1387           echo "XEN_INITRD = '$(XEN_INITRD)'"; \
1388           echo "KVM_KERNEL = '$(KVM_KERNEL)'"; \
1389           echo "FILE_STORAGE_DIR = '$(FILE_STORAGE_DIR)'"; \
1390           echo "ENABLE_FILE_STORAGE = $(ENABLE_FILE_STORAGE)"; \
1391           echo "SHARED_FILE_STORAGE_DIR = '$(SHARED_FILE_STORAGE_DIR)'"; \
1392           echo "ENABLE_SHARED_FILE_STORAGE = $(ENABLE_SHARED_FILE_STORAGE)"; \
1393           echo "IALLOCATOR_SEARCH_PATH = [$(IALLOCATOR_SEARCH_PATH)]"; \
1394           echo "KVM_PATH = '$(KVM_PATH)'"; \
1395           echo "IP_PATH = '$(IP_PATH)'"; \
1396           echo "SOCAT_PATH = '$(SOCAT)'"; \
1397           echo "SOCAT_USE_ESCAPE = $(SOCAT_USE_ESCAPE)"; \
1398           echo "SOCAT_USE_COMPRESS = $(SOCAT_USE_COMPRESS)"; \
1399           echo "LVM_STRIPECOUNT = $(LVM_STRIPECOUNT)"; \
1400           echo "TOOLSDIR = '$(toolsdir)'"; \
1401           echo "GNT_SCRIPTS = [$(foreach i,$(notdir $(gnt_scripts)),'$(i)',)]"; \
1402           echo "HTOOLS_PROGS = [$(foreach i,$(HS_HTOOLS_PROGS),'$(i)',)]"; \
1403           echo "PKGLIBDIR = '$(pkglibdir)'"; \
1404           echo "DRBD_BARRIERS = '$(DRBD_BARRIERS)'"; \
1405           echo "DRBD_NO_META_FLUSH = $(DRBD_NO_META_FLUSH)"; \
1406           echo "SYSLOG_USAGE = '$(SYSLOG_USAGE)'"; \
1407           echo "DAEMONS_GROUP = '$(DAEMONS_GROUP)'"; \
1408           echo "ADMIN_GROUP = '$(ADMIN_GROUP)'"; \
1409           echo "MASTERD_USER = '$(MASTERD_USER)'"; \
1410           echo "MASTERD_GROUP = '$(MASTERD_GROUP)'"; \
1411           echo "RAPI_USER = '$(RAPI_USER)'"; \
1412           echo "RAPI_GROUP = '$(RAPI_GROUP)'"; \
1413           echo "CONFD_USER = '$(CONFD_USER)'"; \
1414           echo "CONFD_GROUP = '$(CONFD_GROUP)'"; \
1415           echo "NODED_USER = '$(NODED_USER)'"; \
1416           echo "NODED_GROUP = '$(NODED_GROUP)'"; \
1417           echo "DISK_SEPARATOR = '$(DISK_SEPARATOR)'"; \
1418           echo "QEMUIMG_PATH = '$(QEMUIMG_PATH)'"; \
1419           echo "HTOOLS = True"; \
1420           echo "ENABLE_CONFD = $(ENABLE_CONFD)"; \
1421           echo "XEN_CMD = '$(XEN_CMD)'"; \
1422           echo "ENABLE_SPLIT_QUERY = $(ENABLE_SPLIT_QUERY)"; \
1423           echo "ENABLE_RESTRICTED_COMMANDS = $(ENABLE_RESTRICTED_COMMANDS)"; \
1424           echo "ENABLE_MONITORING = $(ENABLE_MONITORING)"; \
1425 ## Write dictionary with man page name as the key and the section number as the
1426 ## value
1427           echo "MAN_PAGES = {"; \
1428           for i in $(notdir $(man_MANS)); do \
1429             echo "$$i" | sed -re 's/^(.*)\.([0-9]+)$$/  "\1": \2,/g'; \
1430           done; \
1431           echo "}"; \
1432         } > $@
1433
1434 lib/_vcsversion.py: Makefile vcs-version | stamp-directories
1435         set -e; \
1436         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
1437         { echo '# This file is automatically generated, do not edit!'; \
1438           echo '#'; \
1439           echo ''; \
1440           echo '"""Build-time VCS version number for Ganeti.'; \
1441           echo '';\
1442           echo 'This file is autogenerated by the build process.'; \
1443           echo 'For any changes you need to re-run ./configure (and'; \
1444           echo 'not edit by hand).'; \
1445           echo ''; \
1446           echo '"""'; \
1447           echo ''; \
1448           echo '# pylint: disable=C0301,C0324'; \
1449           echo '# because this is autogenerated, we do not want'; \
1450           echo '# style warnings' ; \
1451           echo ''; \
1452           echo "VCS_VERSION = '$$VCSVER'"; \
1453         } > $@
1454
1455 lib/_generated_rpc.py: lib/rpc_defs.py $(BUILD_RPC)
1456         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(BUILD_RPC) lib/rpc_defs.py > $@
1457
1458 $(SHELL_ENV_INIT): Makefile stamp-directories
1459         set -e; \
1460         { echo '# Allow overriding for tests'; \
1461           echo 'readonly LOCALSTATEDIR=$${LOCALSTATEDIR:-$${GANETI_ROOTDIR:-}$(localstatedir)}'; \
1462           echo 'readonly SYSCONFDIR=$${SYSCONFDIR:-$${GANETI_ROOTDIR:-}$(sysconfdir)}'; \
1463           echo; \
1464           echo 'readonly PKGLIBDIR=$(pkglibdir)'; \
1465           echo 'readonly LOG_DIR="$$LOCALSTATEDIR/log/ganeti"'; \
1466           echo 'readonly RUN_DIR="$$LOCALSTATEDIR/run/ganeti"'; \
1467           echo 'readonly DATA_DIR="$$LOCALSTATEDIR/lib/ganeti"'; \
1468           echo 'readonly CONF_DIR="$$SYSCONFDIR/ganeti"'; \
1469         } > $@
1470
1471 ## Writes sed script to replace placeholders with build-time values. The
1472 ## additional quotes after the first @ sign are necessary to stop configure
1473 ## from replacing those values as well.
1474 $(REPLACE_VARS_SED): $(SHELL_ENV_INIT) Makefile stamp-directories
1475         set -e; \
1476         { echo 's#@''PREFIX@#$(prefix)#g'; \
1477           echo 's#@''SYSCONFDIR@#$(sysconfdir)#g'; \
1478           echo 's#@''LOCALSTATEDIR@#$(localstatedir)#g'; \
1479           echo 's#@''BINDIR@#$(bindir)#g'; \
1480           echo 's#@''SBINDIR@#$(sbindir)#g'; \
1481           echo 's#@''LIBDIR@#$(libdir)#g'; \
1482           echo 's#@''GANETI_VERSION@#$(PACKAGE_VERSION)#g'; \
1483           echo 's#@''CUSTOM_XEN_BOOTLOADER@#$(XEN_BOOTLOADER)#g'; \
1484           echo 's#@''CUSTOM_XEN_KERNEL@#$(XEN_KERNEL)#g'; \
1485           echo 's#@''CUSTOM_XEN_INITRD@#$(XEN_INITRD)#g'; \
1486           echo 's#@''CUSTOM_IALLOCATOR_SEARCH_PATH@#$(IALLOCATOR_SEARCH_PATH)#g'; \
1487           echo 's#@''CUSTOM_EXPORT_DIR@#$(EXPORT_DIR)#g'; \
1488           echo 's#@''RPL_FILE_STORAGE_DIR@#$(FILE_STORAGE_DIR)#g'; \
1489           echo 's#@''RPL_SSH_INITD_SCRIPT@#$(SSH_INITD_SCRIPT)#g'; \
1490           echo 's#@''PKGLIBDIR@#$(pkglibdir)#g'; \
1491           echo 's#@''GNTMASTERUSER@#$(MASTERD_USER)#g'; \
1492           echo 's#@''GNTRAPIUSER@#$(RAPI_USER)#g'; \
1493           echo 's#@''GNTCONFDUSER@#$(CONFD_USER)#g'; \
1494           echo 's#@''GNTNODEDUSER@#$(NODED_USER)#g'; \
1495           echo 's#@''GNTRAPIGROUP@#$(RAPI_GROUP)#g'; \
1496           echo 's#@''GNTADMINGROUP@#$(ADMIN_GROUP)#g'; \
1497           echo 's#@''GNTCONFDGROUP@#$(CONFD_GROUP)#g'; \
1498           echo 's#@''GNTMASTERDGROUP@#$(MASTERD_GROUP)#g'; \
1499           echo 's#@''GNTDAEMONSGROUP@#$(DAEMONS_GROUP)#g'; \
1500           echo 's#@''CUSTOM_ENABLE_CONFD@#$(ENABLE_CONFD)#g'; \
1501           echo 's#@''MODULES@#$(strip $(lint_python_code))#g'; \
1502           echo 's#@''XEN_CONFIG_DIR@#$(XEN_CONFIG_DIR)#g'; \
1503           echo; \
1504           echo '/^@SHELL_ENV_INIT@$$/ {'; \
1505           echo '  r $(SHELL_ENV_INIT)'; \
1506           echo '  d'; \
1507           echo '}'; \
1508         } > $@
1509
1510 # Using deferred evaluation
1511 daemons/ganeti-%: MODULE = ganeti.server.$(patsubst ganeti-%,%,$(notdir $@))
1512 daemons/ganeti-watcher: MODULE = ganeti.watcher
1513 scripts/%: MODULE = ganeti.client.$(subst -,_,$(notdir $@))
1514 tools/burnin: MODULE = ganeti.tools.burnin
1515 tools/ensure-dirs: MODULE = ganeti.tools.ensure_dirs
1516 tools/node-daemon-setup: MODULE = ganeti.tools.node_daemon_setup
1517 tools/prepare-node-join: MODULE = ganeti.tools.prepare_node_join
1518 tools/node-cleanup: MODULE = ganeti.tools.node_cleanup
1519 $(HS_BUILT_TEST_HELPERS): TESTROLE = $(patsubst test/hs/%,%,$@)
1520
1521 $(PYTHON_BOOTSTRAP): Makefile | stamp-directories
1522         test -n "$(MODULE)" || { echo Missing module; exit 1; }
1523         set -e; \
1524         { echo '#!/usr/bin/python'; \
1525           echo '# This file is automatically generated, do not edit!'; \
1526           echo "# Edit $(MODULE) instead."; \
1527           echo; \
1528           echo '"""Bootstrap script for L{$(MODULE)}"""'; \
1529           echo; \
1530           echo '# pylint: disable=C0103'; \
1531           echo '# C0103: Invalid name'; \
1532           echo; \
1533           echo 'import sys'; \
1534           echo 'import $(MODULE) as main'; \
1535           echo; \
1536           echo '# Temporarily alias commands until bash completion'; \
1537           echo '# generator is changed'; \
1538           echo 'if hasattr(main, "commands"):'; \
1539           echo '  commands = main.commands # pylint: disable=E1101'; \
1540           echo 'if hasattr(main, "aliases"):'; \
1541           echo '  aliases = main.aliases # pylint: disable=E1101'; \
1542           echo; \
1543           echo 'if __name__ == "__main__":'; \
1544           echo '  sys.exit(main.Main())'; \
1545         } > $@
1546         chmod u+x $@
1547
1548 $(HS_BUILT_TEST_HELPERS): Makefile
1549         @test -n "$(TESTROLE)" || { echo Missing TESTROLE; exit 1; }
1550         set -e; \
1551         { echo '#!/bin/sh'; \
1552           echo '# This file is automatically generated, do not edit!'; \
1553           echo "# Edit Makefile.am instead."; \
1554           echo; \
1555           echo "HTOOLS=$(TESTROLE) exec ./test/hs/hpc-htools \"\$$@\""; \
1556         } > $@
1557         chmod u+x $@
1558
1559 stamp-directories: Makefile
1560         $(MAKE) $(AM_MAKEFLAGS) ganeti
1561         @mkdir_p@ $(DIRS) $(BUILDTIME_DIR_AUTOCREATE)
1562         touch $@
1563
1564 # We need to create symlinks because "make distcheck" will not install Python
1565 # files when building.
1566 stamp-srclinks: Makefile | stamp-directories
1567         set -e; \
1568         for i in $(srclink_files); do \
1569           if test ! -f $$i -a -f $(abs_top_srcdir)/$$i; then \
1570             $(LN_S) $(abs_top_srcdir)/$$i $$i; \
1571           fi; \
1572         done
1573         touch $@
1574
1575 .PHONY: ganeti
1576 ganeti:
1577         cd $(top_builddir) && test -h "$@" || { rm -f $@ && $(LN_S) lib $@; }
1578
1579 .PHONY: check-dirs
1580 check-dirs: $(GENERATED_FILES)
1581         @set -e; \
1582         find . -type d \( -name . -o -name .git -prune -o -print \) | { \
1583           error=; \
1584           while read dir; do \
1585             case "$$dir" in \
1586               $(strip $(patsubst %,(./%) ;;,$(DIRCHECK_EXCLUDE) $(DIRS))) \
1587               *) error=1; echo "Directory $$dir not listed in Makefile" >&2 ;; \
1588             esac; \
1589           done; \
1590           for dir in $(DIRS); do \
1591             if ! test -d "$$dir"; then \
1592               echo "Directory $$dir listed in DIRS does not exist" >&2; \
1593               error=1; \
1594             fi \
1595           done; \
1596           test -z "$$error"; \
1597         }
1598
1599 .PHONY: check-local
1600 check-local: check-dirs $(GENERATED_FILES)
1601         $(CHECK_PYTHON_CODE) $(check_python_code)
1602         PYTHONPATH=. $(CHECK_HEADER) $(check_python_code)
1603         $(CHECK_VERSION) $(VERSION) $(top_srcdir)/NEWS
1604         $(CHECK_NEWS) < $(top_srcdir)/NEWS
1605         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(CHECK_IMPORTS) . $(standalone_python_modules)
1606         @expver=$(VERSION_MAJOR).$(VERSION_MINOR); \
1607         error= ; \
1608         if test "`head -n 1 $(top_srcdir)/README`" != "Ganeti $$expver"; then \
1609           echo "Incorrect version in README, expected $$expver" >&2; \
1610           error=1; \
1611         fi; \
1612         for file in doc/iallocator.rst doc/hooks.rst doc/virtual-cluster.rst \
1613             doc/security.rst; do \
1614           if test "`sed -ne '4 p' $(top_srcdir)/$$file`" != \
1615             "Documents Ganeti version $$expver"; then \
1616             echo "Incorrect version in $$file, expected $$expver" >&2; \
1617             error=1; \
1618           fi; \
1619         done; \
1620         if ! test -f $(top_srcdir)/doc/design-$$expver.rst; then \
1621           echo "File $(top_srcdir)/doc/design-$$expver.rst not found" >&2; \
1622           error=1; \
1623         fi; \
1624         if test "`sed -ne '5 p' $(top_srcdir)/doc/design-draft.rst`" != \
1625           ".. Last updated for Ganeti $$expver"; then \
1626           echo "doc/design-draft.rst was not updated for version $$expver" >&2; \
1627           error=1; \
1628         fi; \
1629         for file in configure.ac $(HS_LIBTEST_SRCS) $(HS_PROG_SRCS); do \
1630           if test $$(wc --max-line-length < $(top_srcdir)/$$file) -gt 80; then \
1631             echo "Longest line in $$file is longer than 80 characters" >&2; \
1632             error=1; \
1633           fi; \
1634         done; \
1635         test -z "$$error"
1636
1637 .PHONY: hs-tests
1638 hs-tests: test/hs/htest | $(BUILT_PYTHON_SOURCES)
1639         @rm -f htest.tix
1640         ./test/hs/htest
1641
1642 .PHONY: hs-shell
1643 hs-shell: test/hs/hpc-htools test/hs/hpc-mon-collector $(HS_BUILT_TEST_HELPERS)
1644         @rm -f hpc-htools.tix hpc-mon-collector.tix
1645         HBINARY="./test/hs/hpc-htools" ./test/hs/offline-test.sh
1646
1647 .PHONY: hs-check
1648 hs-check: hs-tests hs-shell
1649
1650 # E111: indentation is not a multiple of four
1651 # E121: continuation line indentation is not a multiple of four
1652 #       (since our indent level is not 4)
1653 # E125: continuation line does not distinguish itself from next logical line
1654 #       (since our indent level is not 4)
1655 # E127: continuation line over-indented for visual indent
1656 #       (since our indent level is not 4)
1657 # note: do NOT add E128 here; it's a valid style error in most cases!
1658 # I've seen real errors, but also some cases were we indent wrongly
1659 # due to line length; try to rework the cases where it is triggered,
1660 # instead of silencing it
1661 # E261: at least two spaces before inline comment
1662 # E501: line too long (80 characters)
1663 PEP8_IGNORE = E111,E121,E125,E127,E261,E501
1664
1665 # For excluding pep8 expects filenames only, not whole paths
1666 PEP8_EXCLUDE = $(subst $(space),$(comma),$(strip $(notdir $(BUILT_PYTHON_SOURCES))))
1667
1668 LINT_TARGETS = pylint pylint-qa
1669 if HAS_PEP8
1670 LINT_TARGETS += pep8
1671 endif
1672 if HAS_HLINT
1673 LINT_TARGETS += hlint
1674 endif
1675
1676 .PHONY: lint
1677 lint: $(LINT_TARGETS)
1678
1679 .PHONY: pylint
1680 pylint: $(GENERATED_FILES)
1681         @test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
1682         $(PYLINT) $(LINT_OPTS) $(lint_python_code)
1683
1684 .PHONY: pylint-qa
1685 pylint-qa: $(GENERATED_FILES)
1686         @test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
1687         cd $(top_srcdir)/qa && \
1688           PYTHONPATH=$(abs_top_srcdir) $(PYLINT) $(LINT_OPTS) \
1689           --rcfile  ../pylintrc $(patsubst qa/%.py,%,$(qa_scripts))
1690
1691 .PHONY: pep8
1692 pep8: $(GENERATED_FILES)
1693         @test -n "$(PEP8)" || { echo 'pep8' not found during configure; exit 1; }
1694         $(PEP8) --ignore='$(PEP8_IGNORE)' --exclude='$(PEP8_EXCLUDE)' \
1695           --repeat $(pep8_python_code)
1696
1697 # FIXME: remove ignore "Use void" when GHC 6.x is deprecated
1698 HLINT_EXCLUDES = src/Ganeti/THH.hs test/hs/hpc-htools.hs
1699 .PHONY: hlint
1700 hlint: $(HS_BUILT_SRCS) src/lint-hints.hs
1701         @test -n "$(HLINT)" || { echo 'hlint' not found during configure; exit 1; }
1702         @rm -f doc/hs-lint.html
1703         if tty -s; then C="-c"; else C=""; fi; \
1704         $(HLINT) --utf8 --report=doc/hs-lint.html --cross $$C \
1705           --ignore "Use first" \
1706           --ignore "Use &&&" \
1707           --ignore "Use void" \
1708           --ignore "Reduce duplication" \
1709           --hint src/lint-hints \
1710           $(filter-out $(HLINT_EXCLUDES),$(HS_LIBTEST_SRCS) $(HS_PROG_SRCS))
1711         @if [ ! -f doc/hs-lint.html ]; then \
1712           echo "All good" > doc/hs-lint.html; \
1713         fi
1714
1715 # a dist hook rule for updating the vcs-version file; this is
1716 # hardcoded due to where it needs to build the file...
1717 dist-hook:
1718         $(MAKE) $(AM_MAKEFLAGS) regen-vcs-version
1719         rm -f $(top_distdir)/vcs-version
1720         cp -p $(srcdir)/vcs-version $(top_distdir)
1721
1722 # a distcheck hook rule for catching revision control directories
1723 distcheck-hook:
1724         if find $(top_distdir) -name .svn -or -name .git | grep .; then \
1725           echo "Found revision control files in final archive." 1>&2; \
1726           exit 1; \
1727         fi
1728         if find $(top_distdir) -name '*.py[co]' | grep .; then \
1729           echo "Found Python byte code in final archive." 1>&2; \
1730           exit 1; \
1731         fi
1732         if find $(top_distdir) -name '*~' | grep .; then \
1733           echo "Found backup files in final archive." 1>&2; \
1734           exit 1; \
1735         fi
1736 # Empty files or directories should not be distributed. They can cause
1737 # unnecessary warnings for packagers. Directories used by automake during
1738 # distcheck must be excluded.
1739         if find $(top_distdir) -empty -and -not \( \
1740             -path $(top_distdir)/_build -or \
1741             -path $(top_distdir)/_inst \) | grep .; then \
1742           echo "Found empty files or directories in final archive." 1>&2; \
1743           exit 1; \
1744         fi
1745         if test -n "$(BUILD_RELEASE)" && \
1746            grep -n -H -E '^\*.*unreleased' $(top_distdir)/NEWS; then \
1747            echo "Found unreleased version in NEWS." >&2; \
1748            exit 1; \
1749         fi
1750         if test -e $(top_distdir)/doc/man-html; then \
1751           echo "Found documentation including man pages in final archive" >&2; \
1752           exit 1; \
1753         fi
1754
1755 # When building a release, stricter checks should be used
1756 distcheck-release dist-release: export BUILD_RELEASE = 1
1757 distcheck-release: distcheck
1758
1759 distrebuildcheck: dist
1760         set -e; \
1761         builddir=$$(mktemp -d $(abs_srcdir)/distrebuildcheck.XXXXXXX); \
1762         trap "echo Removing $$builddir; cd $(abs_srcdir); rm -rf $$builddir" EXIT; \
1763         cd $$builddir; \
1764         tar xzf $(abs_srcdir)/$(distdir).tar.gz; \
1765         cd $(distdir); \
1766         ./configure; \
1767         $(MAKE) maintainer-clean; \
1768         cp $(abs_srcdir)/vcs-version .; \
1769         ./configure; \
1770         $(MAKE) $(AM_MAKEFLAGS)
1771
1772 dist-release: dist
1773         set -e; \
1774         for i in $(DIST_ARCHIVES); do \
1775           echo -n "Checking $$i ... "; \
1776           autotools/check-tar < $$i; \
1777           echo OK; \
1778         done
1779
1780 install-exec-local:
1781         @mkdir_p@ "$(DESTDIR)${localstatedir}/lib/ganeti" \
1782           "$(DESTDIR)${localstatedir}/log/ganeti" \
1783           "$(DESTDIR)${localstatedir}/run/ganeti"
1784
1785 .PHONY: apidoc
1786 if WANT_HSAPIDOC
1787 apidoc: py-apidoc hs-apidoc
1788 else
1789 apidoc: py-apidoc
1790 endif
1791
1792 .PHONY: py-apidoc
1793 py-apidoc: epydoc.conf $(RUN_IN_TEMPDIR) $(GENERATED_FILES)
1794         env - PATH="$$PATH" PYTHONPATH="$$PYTHONPATH" \
1795         $(RUN_IN_TEMPDIR) epydoc -v \
1796           --conf $(CURDIR)/epydoc.conf \
1797           --output $(CURDIR)/$(APIDOC_PY_DIR)
1798
1799 .PHONY: hs-apidoc
1800 hs-apidoc: $(HS_BUILT_SRCS)
1801         @test -n "$(HSCOLOUR)" || \
1802             { echo 'HsColour' not found during configure; exit 1; }
1803         @test -n "$(HADDOCK)" || \
1804             { echo 'haddock' not found during configure; exit 1; }
1805         rm -rf $(APIDOC_HS_DIR)/*
1806         for i in $(ALL_APIDOC_HS_DIRS); do \
1807           @mkdir_p@ $$i; \
1808         done
1809         $(HSCOLOUR) -print-css > $(APIDOC_HS_DIR)/Ganeti/hscolour.css
1810         $(LN_S) ../hscolour.css $(APIDOC_HS_DIR)/Ganeti/HTools/hscolour.css
1811         $(LN_S) ../hscolour.css $(APIDOC_HS_DIR)/Ganeti/Confd/hscolour.css
1812         set -e ; \
1813         cd src; \
1814         if [ "$(HS_NOCURL)" ]; \
1815         then OPTGHC="--optghc=$(HS_NOCURL)"; \
1816         else OPTGHC=""; \
1817         fi; \
1818         if [ "$(HS_PARALLEL3)" ]; \
1819         then OPTGHC="$$OPTGHC --optghc=$(HS_PARALLEL3)"; \
1820         fi; \
1821         if [ "$(HS_REGEX_PCRE)" ]; \
1822         then OPTGHC="$$OPTGHC --optghc=$(HS_REGEX_PCRE)"; \
1823         fi; \
1824         RELSRCS="$(HS_LIB_SRCS:src/%=%) $(patsubst src/%,%,$(filter src/%,$(HS_BUILT_SRCS)))"; \
1825         for file in $$RELSRCS; do \
1826           hfile=`echo $$file|sed 's/\\.hs$$//'`.html; \
1827           $(HSCOLOUR) -css -anchor $$file > ../$(APIDOC_HS_DIR)/$$hfile ; \
1828         done ; \
1829         $(HADDOCK) --odir ../$(APIDOC_HS_DIR) --html --ignore-all-exports -w \
1830           -t ganeti -p haddock-prologue \
1831           --source-module="%{MODULE/.//}.html" \
1832           --source-entity="%{MODULE/.//}.html#%{NAME}" \
1833           $$OPTGHC \
1834           $(filter-out Ganeti/HTools/ExtLoader.hs,$(HS_LIB_SRCS:src/%=%))
1835
1836 .PHONY: TAGS
1837 TAGS: $(GENERATED_FILES)
1838         rm -f TAGS
1839         $(GHC) -e ":etags" -v0 \
1840           $(filter-out -O -Werror,$(HFLAGS)) \
1841           $(HS_NOCURL) $(HS_PARALLEL3) $(HS_REGEX_PCRE) \
1842           $(HS_LIBTEST_SRCS)
1843         find . -path './lib/*.py' -o -path './scripts/gnt-*' -o \
1844           -path './daemons/ganeti-*' -o -path './tools/*' -o \
1845           -path './qa/*.py' | \
1846           etags -l python -a -
1847
1848 .PHONY: coverage
1849 if WANT_HTOOLS
1850 coverage: py-coverage hs-coverage
1851 else
1852 coverage: py-coverage
1853 endif
1854
1855 .PHONY: py-coverage
1856 py-coverage: $(GENERATED_FILES) $(python_tests)
1857         @test -n "$(PYCOVERAGE)" || \
1858             { echo 'python-coverage' not found during configure; exit 1; }
1859         set -e; \
1860         COVERAGE=$(PYCOVERAGE) \
1861         COVERAGE_FILE=$(CURDIR)/$(COVERAGE_PY_DIR)/data \
1862         TEXT_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR)/report.txt \
1863         HTML_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR) \
1864         $(PLAIN_TESTS_ENVIRONMENT) \
1865         $(abs_top_srcdir)/autotools/gen-py-coverage \
1866         $(python_tests)
1867
1868 .PHONY: hs-coverage
1869 hs-coverage: $(haskell_tests) test/hs/hpc-htools test/hs/hpc-mon-collector
1870         rm -f *.tix
1871         $(MAKE) $(AM_MAKEFLAGS) hs-check
1872         @mkdir_p@ $(COVERAGE_HS_DIR)
1873         hpc sum --union $(HPCEXCL) \
1874           htest.tix hpc-htools.tix hpc-mon-collector.tix > coverage-hs.tix
1875         hpc markup --destdir=$(COVERAGE_HS_DIR) coverage-hs.tix
1876         hpc report coverage-hs.tix
1877         $(LN_S) -f hpc_index.html $(COVERAGE_HS_DIR)/index.html
1878
1879 # Special "kind-of-QA" target for htools, needs special setup (all
1880 # tools compiled with -fhpc)
1881 .PHONY: live-test
1882 live-test: all
1883         set -e ; \
1884         cd src; \
1885         rm -f .hpc; $(LN_S) ../.hpc .hpc; \
1886         rm -f *.tix *.mix; \
1887         ./live-test.sh; \
1888         hpc sum --union $(HPCEXCL) $(addsuffix .tix,$(HS_PROGS:src/%=%)) \
1889           --output=live-test.tix ; \
1890         @mkdir_p@ ../$(COVERAGE_HS_DIR) ; \
1891         hpc markup --destdir=../$(COVERAGE_HS_DIR) live-test \
1892           --srcdir=.. $(HPCEXCL) ; \
1893         hpc report --srcdir=.. live-test $(HPCEXCL)
1894
1895 commit-check: distcheck lint apidoc
1896
1897 .PHONY: gitignore-check
1898 gitignore-check:
1899         @if [ -n "`git status --short`" ]; then \
1900           echo "Git status is not clean!" 1>&2 ; \
1901           git status --short; \
1902           exit 1; \
1903         fi
1904
1905 # target to rebuild all man pages (both groff and html output)
1906 .PHONY: man
1907 man: $(man_MANS) $(manhtml)
1908
1909 # Target that builds all binaries (including those that are not
1910 # rebuilt except when running the tests)
1911 .PHONY: really-all
1912 really-all: all $(check_SCRIPTS) $(haskell_tests) $(HS_ALL_PROGS)
1913
1914 # we don't need the ancient implicit rules:
1915 %: %,v
1916 %: RCS/%,v
1917 %: RCS/%
1918 %: s.%
1919 %: SCCS/s.%
1920
1921 -include ./Makefile.local
1922
1923 # vim: set noet :